/*!
*  filename: ej.pager.js
*  version : 12.3
*  Copyright Syncfusion Inc. 2001 - 2014. All rights reserved.
*  Use of this code is subject to the terms of our license.
*  A copy of the current license can be obtained at any time by e-mailing
*  licensing@syncfusion.com. Any infringement will be prosecuted under
*  applicable laws. 
*/
(function (fn) {
    typeof define === 'function' && define.amd ? define(["./../common/ej.core"], fn) : fn();
})
(function () {
	
(function ($, ej, undefined) {

    ej.widget("ejPager", "ej.Pager", {
        _rootCSS: "e-pager",
        validTags: ["div"],
        // default model
        defaults: {
            pageSize: 12,
            pageCount: 10,
            currentPage: 1,
            enableExternalMessage: false,
            externalMessage: "",
			pageSizeMessage: "",
            enableQueryString: false,
            locale: "en-US",
            masterObject: null,
			pageSizeSelected:null,
            enableRTL: false,
            totalRecordsCount: null,
            totalPages: null,
            customText: "",
            showPageInfo: true,
			cssClass: "",
			enabled: true,
            showGoToPage: false,
            isResponsive: false,
            change: null,
        },

        // constructor function
        _init: function () {
            this._initPrivateProperties();
            this.model.enableQueryString && this._queryStringValue();
            this.renderPager();
            if (this.model.isResponsive) this._reSizeHandler();
            this._wireResizing();
            this._wireEvents();
			this.refreshPager();
        },
        _initPrivateProperties: function () {
			if (this.model.pageSize.length > 0) this._pageSize = this.model.pageSize[0];
			else  this._pageSize = this.model.pageSize;
            this._links = [];
            this._$prev = null;
            this._$first = null;
            this._$PP = null;
            this._$NP = null;
            this._lastNP = false;
            this._lastpageCount = null;
            this._$last = null;
            this._$next = null;
            this._prevPageNo = 1;
            this.localizedLabels = this._getLocalizedLabels();
			this._intervalWid = 0;
			this._msgWidth = 0;
			this._gotoWid = 0;
        },
        _wireEvents: function () {
			var proxy= this;
                this._on(this.element, "click", this._pagerClickHandler);
              //  $(document).on("mousedown", $.proxy(proxy.hidedrop, proxy));
        },
		_hidedrop: function() {
			if(this.$dropItem && this.$dropItem.css("display") != "none") this.$dropItem.hide();
		},
        _wireResizing: function () {
			this._refreshDropandTextItems();
		   $(window).bind('resize', (this.model.isResponsive)  ? $.proxy(this._reSizeHandler, this)  : $.proxy(this._unWireResizing, this));
        },
        _unWireResizing: function () {
			this._refreshDropandTextItems();
			if (this.$dropItem) if (this.$dropItem.css("display") != "none") this.$dropItem.hide();
            $(window).unbind('resize', $.proxy(this._reSizeHandler, this));
        },
        _reSizeHandler: function () {
			if (this.$dropItem) if (this.$dropItem.css("display") != "none") this.$dropItem.hide();
			controlwidth = this._intervalWid + this._gotoWid + this.element.find('.e-pagercontainer').outerWidth()+this._msgWidth;
			if (controlwidth > (this.element.outerWidth()-20)) {if (this._msgWidth > 0) this.element.find(".e-parentmsgbar").addClass("e-msg-res");}
			else if(this._msgWidth > 0) this.element.find(".e-parentmsgbar").removeClass("e-msg-res");
            if (this.element.outerWidth() - $(this.element.contents()[0]).outerWidth() < 40) {
                this._flag = true;
                this._fillScreen();
            }
            if (this.element.outerWidth() - $(this.element.contents()[0]).outerWidth() > 40) {                
                this.option("pageCount", this._maxPageCount);
                if (this.element.outerWidth() - $(this.element.contents()[0]).outerWidth() < 40) {
                    this._flag = true;
                    this._fillScreen();
                }
            }
			this._refreshDropandTextItems();
        },
		_refreshDropandTextItems: function() {
			if(this.numTextbox) { 
				if (this.element.find('.e-pagercontainer').position().top != this.element.find(".e-parentmsgbar").position().top) {
					this.numTextbox.addClass("e-pager-goto-res"); }
				else this.numTextbox.removeClass("e-pager-goto-res");
			}
			if (this.pageInterval_wrap) {
				if (this.element.find('.e-pagercontainer').position().top != this.element.find(".e-pager-itemsinterval").position().top) {
					this.element.find(".e-pager-itemsinterval").addClass("e-pager-goto-res");
				}
				else this.element.find(".e-pager-itemsinterval").removeClass("e-pager-goto-res");
			}		
			
			
		},
        renderPager: function () {
            var $pagerContainer = ej.buildTag('div.e-pagercontainer', "", {}, { unselectable: "on" });
            this._renderPagerContainer($pagerContainer);
            this.element[0].appendChild($pagerContainer[0]);
            this._pageInfo();
           if (this.model.showGoToPage) this._renderTextboxItem();
			if (this.model.pageSize.length > 0) this._renderDropdownlist();
            this.model.enableExternalMessage && this._renderPagerMessage();
            if (this.model.enableRTL) this.element.addClass("e-rtl");
			if (!this.model.enabled) this._disable();
			this._cssClass = this.model.cssClass; this.element.addClass(this.model.cssClass);
        },
		_removeDropdownlist: function() {
		    this.pageInterval_wrap.remove();
			this.$textspan = null;
			this.$dropItem = null;
		},
		_renderDropdownlist: function () {
			var proxy = this;
			this.pageInterval_wrap =  ej.buildTag('div.e-pager-itemsinterval', "", {}, { unselectable: "on" });
			var pageDrop_wrap =  ej.buildTag('div.e-drpdwndiv e-icon e-arrow-sans-down', "", {}, { unselectable: "on" });
		            this.$textspan = ej.buildTag('span.e-text');
		            this.sizeIntervals = this.model.pageSize;
					pageDrop_wrap.appendTo(this.pageInterval_wrap);
					
					this.pageInterval_wrap.appendTo(this.element);
					this.pageInterval_wrap.insertBefore(this._parentMsgBar);
					this.$textspan.appendTo(pageDrop_wrap);
					proxy.$textspan.text(this.model.pageSize[0]);
					this.$dropItem = ej.buildTag('ul.e-drpdwn e-ul');
					this._renderItems();
					this.$dropItem.appendTo(pageDrop_wrap);
					this._renderPageSizeMessage();
					pageDrop_wrap.on("click", function() {
					if (proxy.$dropItem.css("display") != "none") proxy.$dropItem.hide();
						else {if (proxy.model.enabled) proxy.$dropItem.show()};
					});
					this.$dropItem.hide();
					this.$dropItem.find("li").on("click", function () {
						 proxy.$dropItem.find("li.e-active").removeClass("e-active");
						 $(this).addClass("e-active")
						 proxy._pageSize = $(this).text();
						 proxy.$textspan.text($(this).text());
						 proxy.refreshPager();
						 proxy._trigger("pageSizeSelected", { pageSize: proxy._pageSize });
						 if (proxy._prevPageNo != proxy.model.currentPage)
						     proxy._trigger("change", { "currentPage": proxy.model.currentPage,"isInteraction":true, "event": event });

					});
				this._intervalWid = this.element.find('.e-pager-itemsinterval').outerWidth();
		},
		_renderPageSizeMessage: function () {
		    var msgwrapper = ej.buildTag('div.e-interval-msg');
		    msgwrapper.appendTo(this.pageInterval_wrap);
		    if (this.model.pageSizeMessage.toString().length)
		        msgwrapper.html(this.model.pageSizeMessage);
		    else
		        msgwrapper.hide();
		},
		_renderItems: function() {
				var proxy=this;
					$(this.model.pageSize).each(function() {
						li = ej.buildTag('li');
						li.text(this);
						proxy.$dropItem.append(li);
					});
					this.$dropItem.find("li").first().addClass("e-active");
		},
        _queryStringValue: function () {
            var results = new RegExp('[\\?&]page=([^&#]*)').exec(window.location.href);
            !results ? this.model.currentPage = 1 : this.model.currentPage = parseInt(results[1] || 1);
        },
        _renderPagerMessage: function () {
            var $messageDiv = ej.buildTag('div.e-pagermessage');
            if (this.model.externalMessage.toString().length)
                $messageDiv.html(this.model.externalMessage);
            else
                $messageDiv.hide();
            this.element.append($messageDiv);
        },
		_removePagerMessage: function() {
			this.element.find("div.e-pagermessage").remove();
		},
		_mouseScroll: function(event) {
		 var delta;		 
            if (event.keyCode == "38")
                this._updateField("increment");
            else if (event.keyCode == "40")
                this._updateField("decrement");
        },
        _updateField: function (operation) {
            var preval = this.model.currentPage;
            var step = 1;
            if (this.numTextbox.val() == "") this.numTextbox.val(1);
            else if (this.numTextbox.val().indexOf(" ") >= 1)
                this.numTextbox.val(this._textBox.val().replace(" ", ""));
                this.model.currentPage = ej.parseFloat(this.numTextbox.val(), this.model.locale);
            if (isNaN(this.model.currentPage) && !this.model.currentPage) this.model.currentPage = 1;
            if (this.model.currentPage >= 1 && this.model.currentPage > this.model.totalPages) {
                this.model.currentPage = this.model.totalPages;
				this.numTextbox.val(this.model.currentPage);
            }
            else if (this.model.currentPage < 1 && this.model.currentPage <= this.model.totalPages) {
                this.model.currentPage = 1;
				this.numTextbox.val(this.model.currentPage);
            }
            else if (this.model.currentPage >= 1 && this.model.currentPage <= this.model.totalPages) {
                value = operation == "increment" ? this.model.currentPage + step : this.model.currentPage - step;
                if (value >= 1 && value <= this.model.totalPages) {
                    this.numTextbox.val(value);
					this.model.currentPage = value;
				}
            }
            this.refreshPager();
            if (preval != this.model.currentPage) {
                this._trigger("change", { "currentPage": this.model.currentPage,"isInteraction":true, "event": event });
            }
        },
        _renderTextboxItem: function () {
            proxy = this;
            var numInput = ej.buildTag("input#" + this.element[0].id + "_numtext", "", {}, { "type": "textbox" });
            $(numInput).appendTo(this._parentMsgBar).insertBefore($(this._parentMsgBar).find("span"));
            this.numTextbox = numInput;
            this.numTextbox.height(this.element.find('.e-pagercontainer .e-numericcontainer a').outerHeight());
            this.numTextbox.width(35);
            this.numTextbox.addClass('e-gototextbox e-textbox');
            if (!this.model.showGoToPage) this.numTextbox.hide();
            this._gotoWid = $(this.numTextbox).outerWidth();
			this._on($(this.numTextbox),'keydown', this._mouseScroll);
			this._on(this.numTextbox,'focusout', function(e) {
                e.currentTarget.value = parseInt(e.currentTarget.value);
				var regEx= /^[0-9]*$/;
				var flag = regEx.test(parseInt(e.currentTarget.value));
				if (!flag) {
					proxy.numTextbox.val(proxy.model.currentPage) 
				return false;
				}
				if (proxy.model.currentPage != parseInt(e.currentTarget.value)) {
				if (parseInt(e.currentTarget.value)>= 1 && parseInt(e.currentTarget.value) <= proxy.model.totalPages) {
                        proxy.model.currentPage = parseInt(e.currentTarget.value);
                        proxy.refreshPager();
                        if (proxy._prevPageNo != proxy.model.currentPage)
                            proxy._trigger("change", { "currentPage": proxy.model.currentPage,"isInteraction":true, "event": event });
                    }
                    else proxy.numTextbox.val(this.model.currentPage);
                }
            });

        },
        _renderPagerContainer: function ($pagerContainer) {
            //Update pager styles here for next versions
            this._renderBackwardButton($pagerContainer);
            this._renderpreviousPager($pagerContainer);
            this._renderNumericItem($pagerContainer);
            this._renderForwardPager($pagerContainer);
            this._renderForwardButton($pagerContainer);
        },
        _renderMsgBar: function () {
            var $msgBar = ej.buildTag('span.e-pagermsg', String.format(this.localizedLabels.pagerInfo, this.model.currentPage, this.model.totalPages || 0, this.model.totalRecordsCount || 0));
            this._parentMsgBar.appendChild($msgBar[0]);
            this._parentMsgBar.style.textAlign = ej.TextAlign.Right;
        },
        _renderpreviousPager: function ($pagerContainer) {
            this._$PP = ej.buildTag('a.e-link e-nextprevitemdisabled e-disable e-spacing e-PP', "...", {}, { title: this.localizedLabels.previousPagerTooltip, role: "link" });
            $pagerContainer.append(this._$PP);
        },
        _renderForwardPager: function ($pagerContainer) {
            this._$NP = ej.buildTag('a.e-link e-NP e-numericitem e-spacing e-default', "...", {}, { title: this.localizedLabels.nextPagerTooltip, role: "link" });
            $pagerContainer.append(this._$NP);
        },
        _renderBackwardButton: function ($pagerContainer) {
            this._$first = ej.buildTag('div.e-firstpage e-icon e-mediaback  e-firstpagedisabled e-disable', "", {}, { unselectable: "on", title: this.localizedLabels.firstPageTooltip });
            this._$prev = ej.buildTag('div.e-prevpage e-icon e-arrowheadleft-2x  e-prevpagedisabled e-disable', "", {}, { unselectable: "on", title: this.localizedLabels.previousPageTooltip });
            $pagerContainer.append(this._$first);
            $pagerContainer.append(this._$prev);
        },
        _renderNumericItem: function ($pagerContainer) {
            var $numericContainer = ej.buildTag('div.e-numericcontainer e-default', "", {}, { unselectable: "on" });
            this._renderNumericLinks($numericContainer, this.model.pageCount);
            $pagerContainer.append($numericContainer);
            this._maxPageCount = this.model.pageCount;
        },
        _renderNumericLinks: function ($numericContainer) {
            $numericContainer.empty();
            this.model.pageCount = Math.round(this.model.pageCount);
            for (var page = 1; page <= this.model.pageCount; page++) {
                var $link = ej.buildTag('a.e-link', this.model.customText + page, {}, { role: "link" }).addClass("e-numericitem e-spacing e-default").data("index", page);
                if (page == this.model.currentPage)
                    $link.removeClass("e-default").addClass("e-currentitem e-active");
                $numericContainer.append($link);
            }
            this._links = $numericContainer.children();
        },
        _renderForwardButton: function ($pagerContainer) {
            this._$next = ej.buildTag('div.e-nextpage e-icon e-arrowheadright-2x  e-default', "", {}, { unselectable: "on", title: this.localizedLabels.nextPageTooltip });
            this._$last = ej.buildTag('div.e-lastpage e-icon e-mediaforward  e-default', "", {}, { unselectable: "on", title: this.localizedLabels.lastPageTooltip });
            $pagerContainer.append(this._$next);
            $pagerContainer.append(this._$last);

        },
		_setLocale: function () {
			this.localizedLabels = this._getLocalizedLabels();
			this._$first.attr("title", this.localizedLabels.firstPageTooltip);
			this._$prev.attr("title", this.localizedLabels.previousPageTooltip);
			this._$next.attr("title", this.localizedLabels.nextPageTooltip);
			this._$last.attr("title", this.localizedLabels.lastPageTooltip);
			this._$NP.attr("title", this.localizedLabels.nextPagerTooltip);
			this._$NP.attr("title", this.localizedLabels.previousPagerTooltip);
		},
        _applyCss: function () {
            if (this.model.currentPage > 1) {
                this._$prev.removeClass("e-prevpagedisabled").removeClass("e-disable").addClass("e-prevpage e-default");
                this._$first.removeClass("e-firstpagedisabled").removeClass("e-disable").addClass("e-firstpage e-default");
            } else {
                this._$prev.addClass("e-prevpagedisabled e-disable").removeClass("e-prevpage").removeClass("e-default");
                this._$first.addClass("e-firstpagedisabled e-disable").removeClass("e-firstpage").removeClass("e-default");
            }
            (this.model.currentPage > this.model.pageCount) ?
                 (this._$PP.removeClass("e-nextprevitemdisabled").removeClass("e-disable").addClass("e-numericitem e-default")) : (this._$PP.addClass("e-nextprevitemdisabled e-disable").removeClass("e-numericitem").removeClass("e-default"));

            if (this._links.length && parseInt(this._links[0].innerHTML.replace(this.model.customText, ""), 10) + this.model.pageCount > this.model.totalPages)
                this._lastNP = true;
            else
                this._lastNP = false;

            if (this._lastNP == false)
                this._$NP.removeClass("e-nextprevitemdisabled").removeClass("e-disable").addClass("e-numericitem e-default");
            else
                this._$NP.addClass("e-nextprevitemdisabled e-disable").removeClass("e-numericitem").removeClass("e-default");

            this._lastpageCount = this.model.totalPages % this.model.pageCount;
            if (this._lastpageCount == 0)
                this._lastpageCount = this.model.pageCount;
            if (this.model.currentPage > (this.model.totalPages - this._LastpageCount)) {
                this._$PP.removeClass("e-nextprevitemdisabled").removeClass("e-disable").addClass("e-numericitem e-default");
                this._$NP.addClass("e-nextprevitemdisabled e-disable").removeClass("e-numericitem").removeClass("e-default");
            }
            if (this.model.currentPage == this.model.totalPages || this.model.totalRecordsCount == 0) {
                this._$last.addClass("e-lastpagedisabled e-disable").removeClass("e-lastpage").removeClass("e-default");
                this._$next.addClass("e-nextpagedisabled e-disable").removeClass("e-nextpage").removeClass("e-default");
                this._$NP.addClass("e-nextprevitemdisabled e-disable").removeClass("e-numericitem").removeClass("e-default");
            } else {
                this._$last.addClass("e-lastpage e-default").removeClass("e-lastpagedisabled").removeClass("e-disable");
                this._$next.addClass("e-nextpage e-default").removeClass("e-nextpagedisabled").removeClass("e-disable");
            }
            if (this._links.length) {
                this._links.removeClass("e-currentitem").removeClass("e-active").addClass("e-default");
                $(this._links[(this.model.currentPage - 1) % this.model.pageCount]).removeClass("e-default").addClass("e-currentitem e-active");
                $(this._links[(this._prevPageNo - 1) % this.model.pageCount]).removeClass("e-default").addClass("e-numericitem");
            }
            if (this._pageSize >= (this.model.totalRecordsCount / this.model.pageCount) && this._$PP != null && this._$PP.length != 0) {
                this._$PP.addClass("e-nextprevitemdisabled e-disable").removeClass("e-numericitem").removeClass("e-default");
                this._$NP.addClass("e-nextprevitemdisabled e-disable").removeClass("e-numericitem").removeClass("e-default");
            }
        },
        _SetTotalPages: function () {
            this.model.totalPages = (this.model.totalRecordsCount % this._pageSize == 0) ? (this.model.totalRecordsCount / this._pageSize) : (parseInt(this.model.totalRecordsCount / this._pageSize, 10) + 1);
        },
        _refreshNumericItem: function () {
            if (this._links.length != 0 && this._links != null) {
                this.model.currentPage = this.model.totalPages == 1 ? 1 : this.model.currentPage;
                if (this.model.currentPage > this.model.totalPages && this.model.totalPages != 0)
                    this.model.currentPage = this.model.totalPages;
                var _pagerTarget = parseInt(this.model.currentPage / this.model.pageCount, 10);
                if (this.model.currentPage % this.model.pageCount == 0)
                    if (_pagerTarget > 0)
                        _pagerTarget = _pagerTarget - 1;
                this._links.css("display", "none");
                for (var i = 0; i < this.model.pageCount; i++) {
                    var start = (_pagerTarget * this.model.pageCount) + 1 + i;
                    if (start <= this.model.totalPages) {
                        this._links[i].style.display = '';
                        $(this._links[i]).data('index', start);
                        $(this._links[i]).html(this.model.customText + start);
                    }
                }
            }
        },
        _refreshPagerInfo: function () {
            if (this.model.totalRecordsCount == 0)
                this.model.currentPage = 0;
            this.element.find(".e-pagermsg").text(String.format(this.localizedLabels.pagerInfo, this.model.currentPage, this.model.totalPages || 0, this.model.totalRecordsCount || 0));
        },
        _refreshExternalMessage: function () {
            if (this.model.externalMessage.toString().length)
                this.element.find(".e-pagermessage").empty().html(this.model.externalMessage).show();
            else
                this.element.find(".e-pagermessage").hide();
        },
        refreshPager: function () {
            this._SetTotalPages();
            this._refreshNumericItem();
            this._refreshPagerInfo();
            this._applyCss();
            this.model.enableExternalMessage && this._refreshExternalMessage();
            if (this.model.enableRTL)
                this.element.addClass("e-rtl");
            else
                this.element.removeClass("e-rtl");
            if (this.numTextbox) this.numTextbox.val(this.model.currentPage);
        },

        _kDownHandler: function (e) {
            var code;
            if (e.keyCode) code = e.keyCode; // ie and mozilla/gecko
            else if (e.which) code = e.which; // ns4 and opera
            else code = e.charCode;
            e.target = null;
            if (this.model.masterObject.checkKey("firstPage", code, e))
                e.target = this._$first;
            else if (this.model.masterObject.checkKey("previousPager", code, e))
                e.target = this._$PP;
            else if (this.model.masterObject.checkKey("previousPage", code, e))
                e.target = this._$prev;
            else if (this.model.masterObject.checkKey("lastPage", code, e))
                e.target = this._$last;
            else if (this.model.masterObject.checkKey("nextPager", code, e))
                e.target = this._$NP;
            else if (this.model.masterObject.checkKey("nextPage", code, e))
                e.target = this._$next;
            else
                return false;
            this._pagerClickHandler(e);
        },
        _pageInfo: function ($pagerContainer) {
            if ((this.model.showPageInfo || this.model.showGoToPage) && !this._parentMsgBar) {
                this._parentMsgBar = document.createElement("div");
                this._parentMsgBar.className += "e-parentmsgbar";
                if (this.model.showPageInfo)
                    this._renderMsgBar();
                this.element[0].appendChild(this._parentMsgBar);
                this.element[0].className += this.model.enableRTL ? " e-pager e-rtl" : " e-pager";
            } else {
                this._parentMsgBar && this._parentMsgBar.remove();
                this._parentMsgBar = null;
            }
            this._msgWidth = $(this._parentMsgBar).outerWidth()
        },
        _doClickAnimation: function (event) {
            var element = $(event.target);
            if (element == undefined || event.type == undefined) return;
            element.addClass("e-animate");
        },
        _pagerClickHandler: function (e) {
            if (!this.model.enabled) return false;
            this._prevPageNo = this.model.currentPage;
            var $target = $(e.target);
            this.element.find(".e-animate").removeClass("e-animate");
            this._doClickAnimation(e);
            if ($.inArray(e.target, this._links) != -1) {
                this.model.currentPage = parseInt($(e.target).data("index"), 10);
            }
            else if ($target.hasClass("e-nextpage") && $target.hasClass("e-nextpagedisabled") != true) {
                if (this.model.currentPage % this.model.pageCount == 0) {
                    this.model.currentPage++;
                    if (this._links != undefined && this._links.length != 0)
                        this.model.currentPage = parseInt($(this._links[0]).data("index"), 10) + this.model.pageCount;
                    if (parseInt(this._links[this.model.pageCount - 1].innerHTML, 10) + this.model.pageCount >= this.model.totalPages)
                        this._lastNP = true;
                }
                else
                    this.model.currentPage++;
            }
            else if ($target.hasClass("e-prevpage") && $target.hasClass("e-prevpagedisabled") != true) {
                if (this.model.currentPage % this.model.pageCount == 1)
                    this._lastNP = false;
                this.model.currentPage--;
                if (this.model.currentPage < 0) { this.model.currentPage = 0; }
            }
            else if ($target.hasClass("e-lastpage") && $target.hasClass("e-lastpagedisabled") != true) {
                this._LastpageCount = this.model.totalPages % this.model.pageCount;
                (this._LastpageCount == 0) ? (this._LastpageCount = this.model.pageCount) : null;
                this.model.currentPage = this.model.totalPages;
                this._lastNP = true;
            }
            else if ($target.hasClass("e-firstpage") && $target.hasClass("e-firstpagedisabled") != true) {
                this.model.currentPage = 1;
                this._lastNP = false;
            }
            else if ($target.hasClass("e-NP") && $target.hasClass("e-nextprevitemdisabled") != true) {
                if (this._links != undefined)
                    this.model.currentPage = parseInt($(this._links[0]).data("index"), 10) + this.model.pageCount;
                if (parseInt(this._links[this.model.pageCount - 1].innerHTML.replace(this.model.customText, ""), 10) + this.model.pageCount >= this.model.totalPages) {
                    this._lastNP = true;
                    if ((this.model.totalRecordsCount - this._pageSize) < this._pageSize)
                        this._LastpageCount = this.model.totalRecordsCount - this._pageSize;
                    else
                        this._LastpageCount = ((this.model.totalRecordsCount / this._pageSize) % this.model.pageCount);
                    (this._LastpageCount == 0) ? (this._LastpageCount = this.model.pageCount) : null;
                    if (this._links != undefined)
                        this.model.currentPage = parseInt($(this._links[this.model.pageCount - 1]).data("index"), 10) + 1;
                }
            }
            else if ($target.hasClass("e-PP") && $target.hasClass("e-nextprevitemdisabled") != true) {
                if (this._links != undefined)
                    this.model.currentPage = parseInt($(this._links[0]).data("index"), 10) - this.model.pageCount;
                this._lastNP = false;
            }
            else return;
            this.refreshPager();
            this.goToPage(this.model.currentPage, e);
            return false;
        },
        goToPage: function (pageIndex, event) {
            if (pageIndex != this.model.currentPage)
                this._prevPageNo = this.model.currentPage;
            if (this._prevPageNo !== pageIndex && (pageIndex >= 1 && pageIndex <= this.model.totalPages)) {
                this.model.currentPage = pageIndex;
                this.model.enableQueryString && this._updateQueryString(this.model.currentPage);
            }
            if (this._prevPageNo != this.model.currentPage) {
                this._trigger("change", { "currentPage": this.model.currentPage,"isInteraction":true, "event": event });
            }
        },
        _updateQueryString: function (value) {
            var _newUrl = this._getUpdatedURL(window.location.href, "page", value);
            if (history.pushState) {
                window.history.pushState({ path: _newUrl }, '', _newUrl);
            }
            else
                window.location.href = _newUrl;
        },

        _getUpdatedURL: function (uri, key, value) {
            var re = new RegExp("([?|&])" + key + "=.*?(&|#|$)", "i");
            if (uri.match(re)) {
                return uri.replace(re, '$1' + key + "=" + value + '$2');
            } else {
                var hash = '';
                var separator = uri.indexOf('?') !== -1 ? "&" : "?";
                if (uri.indexOf('#') !== -1) {
                    hash = uri.replace(/.*#/, '#');
                    uri = uri.replace(/#.*/, '');
                }
                return uri + separator + key + "=" + value + hash;
            }
        },
        _getLocalizedLabels: function (property) {
            return ej.getLocalizedConstants(this.sfType, this.model.locale);
        },
        _fillScreen: function () {
            var numLen = this.element.find('.e-pagercontainer').outerWidth() - (this._$first.outerWidth() + this._$last.outerWidth() + this._$next.outerWidth() + this._$prev.outerWidth())
            numLen -= this._$NP.hasClass('e-disable') ? 0 : this._$NP.outerWidth();
            numLen -= this._$PP.hasClass('e-disable') ? 0 : this._$PP.outerWidth();
            if (this.element.outerWidth() - $(this.element.contents()[0]).outerWidth() < 40) {
                if (Math.floor(numLen / this.element.find('.e-numericcontainer .e-numericitem.e-spacing.e-default').outerWidth()) - 1 < 1) this._flag? this.option("pageCount", 1) : this.model.pageCount = 1;
                else this._flag ? this.option("pageCount", Math.floor(numLen / this.element.find('.e-numericcontainer .e-numericitem.e-spacing.e-default').outerWidth()) - 1) : this.model.pageCount = Math.floor(numLen / this.element.find('.e-numericcontainer .e-numericitem.e-spacing.e-default').outerWidth()) - 1;
            }
        },
		_enable: function () {
            this.element.removeClass('e-disable').attr({ "aria-disabled": false });
            this.element.prop("disabled", false);
			if(this.numTextbox) this.numTextbox.addClass("e-disable");
		},
		_disable: function () {
            this.element.addClass('e-disable').attr({ "aria-disabled": true });
            this.element.prop("disabled", "disabled");
			if(this.numTextbox) this.numTextbox.removeClass("e-disable");
			if (this.$dropItem) if (this.$dropItem.css("display") != "none") this.$dropItem.hide();
		},
        _setFirst: true,
        _setModel: function (options) {
            for (var prop in options) {
                this._preval = this.model.currentPage;
                switch (prop) {
                    case "pageCount":
                        this._renderNumericLinks(this.element.find(".e-numericcontainer"));
                        if (this.model.isResponsive && !this._flag) {
                            this._maxPageCount = this.model.pageCount;
                            this._fillScreen();
                        }
                        this._flag = false;
                        break;
                    case "enableExternalMessage":
					if (options[prop])
                        this._renderPagerMessage();
					else
						this._removePagerMessage();
                        break;
                    case "showPageInfo":
                        this._pageInfo();
                        break;
                    case "pageSizeMessage":
                        if (options[prop] != null) {
                            this._renderPageSizeMessage();
                        }
                        break;
					case "pageSize":
					this._pageSize = this.model.pageSize;
					if (options[prop].length > 0) {
						this._pageSize = this.model.pageSize[0];
						if (this.$dropItem) {
							this.$dropItem.find("li").remove();
							this._renderItems();
						}
						else this._renderDropdownlist();
					}
					else if (this.$dropItem) this._removeDropdownlist();
						break;
					case "enabled":
						if (!options[prop]) this._disable(); else this._enable(); break;
					case "cssClass":
						this.element.removeClass(this._cssClass).addClass(options[prop]); this._cssClass = this.model.cssClass;
                    case "isResponsive":
                        this._wireResizing();
                        if (!options[prop]) this.option("pageCount", this._maxPageCount);
                        else if (this.model.isResponsive && !this._flag) {
                            this._maxPageCount = this.model.pageCount; this._fillScreen();
                        }
                        this._flag = false;
                        break;
                    case "showGoToPage": if (options[prop]) this._renderTextboxItem(); else if (this.numTextbox) this.numTextbox.remove(); break;
                    case "locale": this._setLocale();
                    case "currentPage": {
                        this.refreshPager();
                        this._trigger("change", { "currentPage": this.model.currentPage, "isInteraction": false });
                    }


                }
            }
            if (prop != "currentPage") {
                this.refreshPager();
                if (this._preval != this.model.currentPage)
                    this._trigger("change", { "currentPage": this.model.currentPage, "isInteraction": false });
            }
        },

        // all events bound using this._on will be unbind automatically
        _destroy: function () {
            this.element.empty().removeClass("e-pager");
            this._unWireResizing();
        }
    });
    ej.Pager.Locale = ej.Pager.Locale || {};

    ej.Pager.Locale["default"] = ej.Pager.Locale["en-US"] = {
        pagerInfo: "{0} of {1} pages ({2} items)",
        firstPageTooltip: "Go to first page",
        lastPageTooltip: "Go to last page",
        nextPageTooltip: "Go to next page",
        previousPageTooltip: "Go to previous page",
        nextPagerTooltip: "Go to next pager",
        previousPagerTooltip: "Go to previous pager"
    };

})(jQuery, Syncfusion);;

});